=== debian/changelog ===
julia (0.3.2-2) unstable; urgency=medium

  * Set a hard dependency on OpenBLAS. (Closes: #778912)

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 21 Feb 2015 18:46:06 +0100

julia (0.3.2-1) unstable; urgency=medium

  * Imported Upstream version 0.3.2
  * Ship new desktop file, SVG icon and appdata file.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 22 Oct 2014 18:42:04 +0200

julia (0.3.1-1) unstable; urgency=medium

  * Imported Upstream version 0.3.1
  * Fix get-orig-source rule with respect to embedded utf8proc.
  * No longer embed sphinx-rtd-theme.
    + Add build-dependency on python-sphinx-rtd-theme.
    + Drop patch embed-sphinx-rtd-theme.patch.
  * Bump Standards-Version to 3.9.6, no changes needed.
  * No longer try the "parallel" test at build time.
    It always fails in chroots.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 24 Sep 2014 11:56:26 +0200

julia (0.3.0-1) unstable; urgency=medium

  * New upstream release.
    - no longer breaks on PCRE upgrades. (Closes: #755576)
    - command-line option "-p" works as expected. (Closes: #758783)
  * Rewrite get-orig-source in d/rules. In particular no longer embed openlibm,
    since it is now a separate package.
  * debian/copyright: reflect upstream changes.
  * New patches:
    + do-not-download-utf8proc.patch
    + inject-ldflags.patch
    + install-sh-exit-status.patch
  * Dropped patches:
    + do-not-download-patchelf.patch (instead build depend on patchelf)
    + fix-cpu-detection.patch
    + ld-library-path-for-testing.patch
    + make-4.0.patch
    + no-git.patch (instead use "make -C base version_git.jl.phony")
    + readline-6.3.patch (Julia no longer uses readline)
    + sysconfdir-install.patch (instead use new make variable)
    + use-sonames-with-dlopen.patch (not really needed, too difficult to
      maintain)
  * Ship the cached binary system image (sys.so).
  * Compile with MARCH=x86-64 on amd64, and with MARCH=pentium4. In particular,
    this means that SSE2 is now required on i386, because x87 FPU computing is
    not supported by upstream and is buggy. Abort nicely if the CPU does have
    SSE2, and by the way activate SSE2 in dSFMT (require-sse2-on-i386.patch).
    As a consequence, drop the now unneeded testsuite-i386.patch.
  * Bump to LLVM 3.5. (Closes: #753971)
  * Add libopenblas-base to Recommends. Having it first in the BLAS
    dependency alternative is not enough to ensure that it is installed by
    default.
  * Use OpenBLAS for both BLAS and LAPACK, since the Debian package now ships
    both.
  * Documentation package (julia-doc):
    + use dh_sphinxdoc
    + use packaged Mathjax instead of online version (with
      use_packaged_mathjax.patch, symbolic links in d/julia-doc.links and
      appropriate logic in d/rules)
    + use packaged awesome font
    + embed sphinx-rtd-theme, since the corresponding package has not yet been
      accepted in sid (embed-sphinx-rtd-theme.patch)

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 20 Aug 2014 10:51:46 +0000

julia (0.2.1+dfsg-3) unstable; urgency=medium

  * make-4.0.patch: fix FTBFS against make 4.0.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 07 May 2014 15:17:37 +0200
